#ifndef LICKS_IK_H
#define LICKS_IK_H

#include "linalg.h"

#define NUM_LEGS 6

typedef struct {
   vector3d leg_offset[NUM_LEGS];
} bot_configuration;

typedef struct {
   vector3d position;
   double   ik_angle[3];
} leg;

typedef struct {
   vector3d world_position;
   vector3d world_orientation;
   vector3d body_position;
   vector3d body_orientation;
   
   leg      leg[NUM_LEGS];
} bot;

extern void ik(bot *);
extern bot_configuration conf;

#endif

